class FarbTafel {
  
float r1,g1,b1;
float r2,g2,b2;
int[] hueZufall = new int[16];
int[] saturationZufall = new int[16];

color[] farbenAnkerchaos; 
color[] farben8192;

color[] farbAnkerOrdnung; 
color[] farben1024;

color[] farbenAnker1024B; 
color[] farben1024B;//Anzahl Farben 1024:, Ankerabstand: 64

color[][] farben8KreiseBonBonAnker1152;
color[] farben8KreiseBonBon1152;//Anzahl Farben 1152:, Ankerabstand: 128

color[][] farben8KreiseAnker1152;
color[] farben8Kreise1152;//Anzahl Farben 1152:, Ankerabstand: 128

color[][] farbenTrapAnkerZufall1024;
color[][] farbenTrapZufall1024;//Anzahl Farben 20 mal 1024:, Ankerabstand: 256

float S1 ; 
float S2 ; 


void farbTafelErzeugen(){
//Farbtafel Chaos ////////////////////////////////////////////////////////////
  farbenAnkerchaos = new color[65];//Initialsierung
  for(int i=0;i<65;i++){
     farbenAnkerchaos[i] = color(0);
  }
  farben8192 = new color[8192];
   for(int i=0;i<8192;i++){
     farben8192[i] = color(0);
  }
 farbenAnkerchaos[0] = color(255);
  
  for(int j=1; j<65; j++){
    farbenAnkerchaos[j] = farbeBestimmen( farbenAnkerchaos[j-1]);  
   
  }  
 
  for(int i=0; i<64; i++){
    zwischenFarbenBestimmen(i*128,farbenAnkerchaos[i],farbenAnkerchaos[i+1]);
  }
 
  //Farbtafel Ordnung/////////////////////////////////////////////////////////
  farbAnkerOrdnung = new color[17];//Initialsierung
  farbAnkerOrdnung[0] = color(0,0,0);
  farbAnkerOrdnung[1] = color(0,0,30);
  farbAnkerOrdnung[2] = color(0,0,60);
  farbAnkerOrdnung[3] = color(0,0,90);
  farbAnkerOrdnung[4] = color(0,30,60);
  farbAnkerOrdnung[5] = color(0,60,30);
  farbAnkerOrdnung[6] = color(0,60,60);
  farbAnkerOrdnung[7] = color(0,30,30);
  farbAnkerOrdnung[8] = color(0,0,0);
  farbAnkerOrdnung[9] = color(0,40,60);
  farbAnkerOrdnung[10] = color(0,50,100);
  farbAnkerOrdnung[11] = color(0,100,150);
  farbAnkerOrdnung[12] = color(0,100,100);
  farbAnkerOrdnung[13] = color(0,150,0);
  farbAnkerOrdnung[14] = color(0,100,0);
  farbAnkerOrdnung[15] = color(0,50,0);
  farbAnkerOrdnung[16] = color(0,0,0);
  
  farben1024 = new color[1024];
   for(int i=0;i<1024;i++){
     farben1024[i] = color(0);
  }
   for(int i=0; i<16; i++){
    zwischenFarbenBestimmenOrdnung(i*64,farbAnkerOrdnung[i],farbAnkerOrdnung[i+1]);
  }
  
  //Farbtafel farben1024B------------------------------------------------------------------------------------
  farbenAnker1024B = new color[17];//Initialsierung und Festlegung, Farbtafel immer gleich!
  farbenAnker1024B[0] = color(0,0,0); 
  farbenAnker1024B[1] = color(0,0,150);
  farbenAnker1024B[2] = color(0,0,200);
  farbenAnker1024B[3] = color(0,150,150);
  farbenAnker1024B[4] = color(0,200,0);
  farbenAnker1024B[5] = color(0,150,00);
  farbenAnker1024B[6] = color(150,150,60);
  farbenAnker1024B[7] = color(200,0,0);
  farbenAnker1024B[8] = color(150,0,150);
  farbenAnker1024B[9] = color(0,150,150);
  farbenAnker1024B[10] = color(0,200,200);
  farbenAnker1024B[11] = color(150,150,0);
  farbenAnker1024B[12] = color(200,200,0);
  farbenAnker1024B[13] = color(150,0,150);
  farbenAnker1024B[14] = color(200,0,200);
  farbenAnker1024B[15] = color(150,150,150);
  farbenAnker1024B[16] = color(0,0,0); 
  
  farben1024B = new color[1024];
   for(int i=0;i<1024;i++){
     farben1024B[i] = color(255);
  }
   for(int i=0; i<16; i++){
    zwischenFarbenBestimmen1024B(i*64,farbenAnker1024B[i],farbenAnker1024B[i+1]);
  }  
  ////////////////////////////////////////////////////////////////////////////
  //farben8KreiseBonBon1152-----------------------------------------------------------------------------------
  farben8KreiseBonBonAnker1152 = new color[9][2];  
  for (int i = 0; i < 9; i++) {
    for (int j = 0; j < 2; j++) {
      farben8KreiseBonBonAnker1152[i][j] = color(255);
    }
  }

 farben8KreiseBonBonAnker1152[0][0] = color(255,0,0);     farben8KreiseBonBonAnker1152[0][1] = color(20,0,0);//rot
 farben8KreiseBonBonAnker1152[1][0] = color(0,255,0);     farben8KreiseBonBonAnker1152[1][1] = color(0,20,0);//grün
 farben8KreiseBonBonAnker1152[2][0] = color(0,0,255);     farben8KreiseBonBonAnker1152[2][1] = color(0,0,20);//blau
 farben8KreiseBonBonAnker1152[3][0] = color(255,255,0);   farben8KreiseBonBonAnker1152[3][1] = color(20,20,0);//gelb 
 farben8KreiseBonBonAnker1152[4][0] = color(255,0,255);   farben8KreiseBonBonAnker1152[4][1] = color(20,0,20);//türkis
 farben8KreiseBonBonAnker1152[5][0] = color(0,255,255);   farben8KreiseBonBonAnker1152[5][1] = color(0,20,20);//magenta
 farben8KreiseBonBonAnker1152[6][0] = color(255,168,0);   farben8KreiseBonBonAnker1152[6][1] = color(20,0,20);///orange
 farben8KreiseBonBonAnker1152[7][0] = color(128,0,255);   farben8KreiseBonBonAnker1152[7][1] = color(20,0,20); //violett
 farben8KreiseBonBonAnker1152[8][0] = color(255);         farben8KreiseBonBonAnker1152[8][1] = color(20); //grau  
 
 
 
 farben8KreiseBonBon1152 = new color[1152];
 for(int i=0;i<1152;i++){
     farben8KreiseBonBon1152[i] = color(255);
  }
 for(int i=0; i<9;i++){
     zwischenFarbenBestimmen8KreiseBonBon1152( i*128,farben8KreiseBonBonAnker1152[i][0] , farben8KreiseBonBonAnker1152[i][1] );
 } 
 /////////////////////////////////////////////////////////////////////////////////////////////
  //farben8Kreise1152-----------------------------------------------------------------------------------
 farben8KreiseAnker1152 = new color[9][2];  
  for (int i = 0; i < 9; i++) {
    for (int j = 0; j < 2; j++) {
      farben8KreiseAnker1152[i][j] = color(255);
    }
  }
 farben8KreiseAnker1152[0][0] = color(255,random(200),random(200)); farben8KreiseAnker1152[0][1] = color(20,0,0);//rötlich
 farben8KreiseAnker1152[1][0] = color(random(200),255,random(200)); farben8KreiseAnker1152[1][1] = color(0,20,0);//grünlich
 farben8KreiseAnker1152[2][0] = color(random(200),random(200),255); farben8KreiseAnker1152[2][1] = color(0,0,20);//bläulich
 farben8KreiseAnker1152[3][0] = color(255,255,random(200));         farben8KreiseAnker1152[3][1] = color(20,20,0);//gelblich 
 farben8KreiseAnker1152[4][0] = color(255,random(200),255);         farben8KreiseAnker1152[4][1] = color(20,0,20);//türkisähnlich
 farben8KreiseAnker1152[5][0] = color(random(200),255,255);         farben8KreiseAnker1152[5][1] = color(0,20,20);//magentaähnlich
 farben8KreiseAnker1152[6][0] = color(248,168,random(200));         farben8KreiseAnker1152[6][1] = color(120,0,40);///orangeähnlich
 farben8KreiseAnker1152[7][0] = color(128,random(200),255);         farben8KreiseAnker1152[7][1] = color(78,0,20); //violettähnlich
 farben8KreiseAnker1152[8][0] = color(255);                         farben8KreiseAnker1152[8][1] = color(20); //grau 
 
  farben8Kreise1152 = new color[1152];
 for(int i=0;i<1152;i++){
     farben8Kreise1152[i] = color(255);
  }
 for(int i=0; i<9;i++){
     zwischenFarbenBestimmen8Kreise1152( i*128,farben8KreiseAnker1152[i][0] , farben8KreiseAnker1152[i][1] );
 } 
 
 
 //////////////////////////////////////////////////////////////////////////////////////////////////////
 //farbenTrapAnkerZufall1024[] 16 Zufallsfarben Verläufe----------------------------------------------------------------
   colorMode(HSB,256,256,256);
  for (int i = 0; i < 16; i++) {
     //hueZufall[i] = (int)random(i*16,(i+1)*16);//Farben hier gleichmäßig verteilt
     hueZufall[i] = (int)random(256);
  }
  for (int i = 0; i < 16; i++) {
     saturationZufall[i] = (int)random(100,256);
  }
  //Initialisierung
  farbenTrapAnkerZufall1024 = new color[20][5];  
    for (int i = 0; i < 16; i++) {
      for (int j = 0; j < 5; j++) {
        farbenTrapAnkerZufall1024[i][j] = color(255);
      }
   }      
   farbenTrapZufall1024 = new color[20][1024];  
   for (int i = 0; i < 16; i++) {
      for (int j = 0; j < 1024; j++) {
        farbenTrapZufall1024[i][j] = color(255);
      }
    }       
  for (int i = 0; i < 16; i++) {//für knallige Farben saturation auf 255 setzen
    farbenTrapAnkerZufall1024[i][0] = color(hueZufall[i],saturationZufall[i],255);
    farbenTrapAnkerZufall1024[i][1] = color(hueZufall[i],saturationZufall[i],100);
    farbenTrapAnkerZufall1024[i][2] = color(hueZufall[i],saturationZufall[i],0);
    farbenTrapAnkerZufall1024[i][3] = color(hueZufall[i],saturationZufall[i],100);
    farbenTrapAnkerZufall1024[i][4] = color(hueZufall[i],saturationZufall[i],255);
  }

  for (int i = 0; i < 16; i++) {
    for(int l=0; l<4; l++){
      zwischenFarbenBestimmenTrapZufall1024(i,l*256,farbenTrapAnkerZufall1024[i][l],farbenTrapAnkerZufall1024[i][l+1]);
    }
  }
 
} 


  ///////////////////////////////////////////////////////////////
  color farbeBestimmen(color f){
    color farbe = color(0);//Initialisierung
    r2=random(256);
    g2=random(256);
    b2=random(256);
    S1 =red(f)+green(f)+blue(f); 
    S2 = r2+g2+b2; 
    while(abs(S1-S2)<255){
       r2=random(256);
       g2=random(256);
       b2=random(256);  
       S2 = r2+g2+b2;     
    }
    farbe = color(r2,g2,b2);
    return farbe;
  }
  
  void zwischenFarbenBestimmen(int k, color f1, color f2){
     int start = k;
     for(int i=start; i<128+start;i++){
        //if(k==256) {println(k,i);delay(100);}
       // println(k,i);
        farben8192[i] = lerpColor(f1,f2,(float)(i-start)/128);
        //println(i,red(farben8192[i]),green(farben8192[i]),blue(farben8192[i]));
       // println(i,f1,f2,farben8192[i],(float)i/4096);
     }
  }
  
  void zwischenFarbenBestimmenOrdnung(int k, color f1, color f2){
     int start = k;
     for(int i=start; i<64+start;i++){
        //if(k==256) {println(k,i);delay(100);}
       // println(k,i);
        farben1024[i] = lerpColor(f1,f2,(float)(i-start)/64);
        //println(i,red(farben1024[i]),green(farben1024[i]),blue(farben1024[i]));
       // println(i,f1,f2,farben1024[i],(float)i/1024);
     }
  }  
  void zwischenFarbenBestimmen1024B(int k, color f1, color f2){//...für farben1024
       int start = k;
       for(int i=start; i<64+start;i++){    
          farben1024B[i] = lerpColor(f1,f2,(float)(i-start)/64);    
       }
  }
  void zwischenFarbenBestimmen8KreiseBonBon1152(int k,color f1, color f2){//...für farben8Kreise1152
       int start = k;
       for(int i =start; i<64+start;i++){
         farben8KreiseBonBon1152[i] = lerpColor(f1,f2,(float)(i-start)/64);     
       }
  } 
  void zwischenFarbenBestimmen8Kreise1152(int k,color f1, color f2){//...für farben8Kreise1152
       int start = k;
       for(int i =start; i<64+start;i++){
         farben8Kreise1152[i] = lerpColor(f1,f2,(float)(i-start)/64);     
       }
  } 
  void zwischenFarbenBestimmenTrapZufall1024(int n, int k, color f1, color f2){//...für farbenTrapBeliebig1024
     int start = k;colorMode(HSB,256,256,256);
     int nummer = n;
     for(int i=start; i<256+start;i++){    
        farbenTrapZufall1024[nummer][i] = lerpColor(f1,f2,(float)(i-start)/256   );     
     }
  }  

}
